using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine;
using UnityEngine.SceneManagement;
using System.Linq;
using TMPro;
using UnityEngine.UI;

namespace Armor
{
    public class Mod
    {
        public static void Main()
        {      
	CategoryBuilder.Create(" SAS", "", ModAPI.LoadSprite("category icon.png"));       




 ModAPI.Register(
		    new Modification()
			{
                    OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                    NameOverride = "[Manchester] Colt M4",
                    DescriptionOverride = " ",
                    NameToOrderByOverride = "4a",
                    CategoryOverride = ModAPI.FindCategory(" SAS"),
                    ThumbnailOverride = ModAPI.LoadSprite("icons/m4icon.png"),
                    AfterSpawn = (Instance) =>
                    {
		       ModAPI.KeepExtraObjects();

		       var M4Slide = Instance.transform.Find("Slide");
                       M4Slide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("slides/m4slide.png", 15f);
                       M4Slide.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);
		       M4Slide.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapon/m4.png", 15f);
                        Instance.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);

                        Instance.FixColliders(); 
                        Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.92f, 0.13f);
		        Instance.GetComponent<FirearmBehaviour>().casingPosition = new Vector2(0.210f,0.100f);  
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.FixColliders();
                        Instance.GetComponent<FirearmBehaviour>().BulletsPerShot = 1;

                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        Instance.GetComponent<FirearmBehaviour>().Automatic = true;
                        Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.16f;

                        firearm.ShotSounds = new AudioClip[]
                        {
                        ModAPI.LoadSound("Sound/m4sound.mp3"),
                        };

                      Cartridge customCartridge = ModAPI.FindCartridge("5.56×45");
                        customCartridge.name = "Colt M4";
                        customCartridge.Damage = 4f;
                        customCartridge.Recoil = 4f;
                        customCartridge.ImpactForce = 7f;
                        firearm.Cartridge = customCartridge;
		    }
                }
            );

 ModAPI.Register(
		    new Modification()
			{
                    OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                    NameOverride = "[Manchester] Colt M4 Variant 2",
                    DescriptionOverride = " ",
                    NameToOrderByOverride = "4b",
                    CategoryOverride = ModAPI.FindCategory(" SAS"),
                    ThumbnailOverride = ModAPI.LoadSprite("icons/m42icon.png"),
                    AfterSpawn = (Instance) =>
                    {
		       ModAPI.KeepExtraObjects();

		       var M4Slide = Instance.transform.Find("Slide");
                       M4Slide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("slides/m4slide.png", 15f);
                       M4Slide.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);
		       M4Slide.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapon/m42.png", 15f);
                        Instance.GetComponent<SpriteRenderer>().color = new Color32(255, 255, 255, 255);

                        var Laser = new GameObject("Laser");
                        Laser.transform.SetParent(Instance.transform);
                        Laser.transform.localPosition = new Vector2(0f, 0f);
                        Laser.transform.localScale = new Vector3(1f, 1f);
                        Laser.transform.rotation = Instance.transform.rotation;
                        var LaserSprite = Laser.AddComponent<SpriteRenderer>();
                        LaserSprite.sprite = ModAPI.LoadSprite("weapon/laser.png", 15f);
                        LaserSprite.sortingLayerName = "Top"; 

                        Instance.FixColliders(); 
                        Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.92f, 0.13f);
		        Instance.GetComponent<FirearmBehaviour>().casingPosition = new Vector2(0.210f,0.100f);  
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
						}
                        Instance.FixColliders();
                        Instance.GetComponent<FirearmBehaviour>().BulletsPerShot = 1;

                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        Instance.GetComponent<FirearmBehaviour>().Automatic = true;
                        Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.16f;

                        firearm.ShotSounds = new AudioClip[]
                        {
                        ModAPI.LoadSound("Sound/m4sound.mp3"),
                        };

                      Cartridge customCartridge = ModAPI.FindCartridge("5.56×45");
                        customCartridge.name = "Colt M4";
                        customCartridge.Damage = 4f;
                        customCartridge.Recoil = 4f;
                        customCartridge.ImpactForce = 7f;
                        firearm.Cartridge = customCartridge;
		    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"), 
                    NameOverride = "[Manchester] Vest Variant 1", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "3a",
                    CategoryOverride = ModAPI.FindCategory(" SAS"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/vestv1icon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/vest1.png", 12); 

                        int PartCount = 3;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f);                  
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/vest1.png", 12);
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;
                        prop.armorPoints = 350;
                        armor.prop = prop;
                        armor.SetProperties();
                        
                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = ModAPI.LoadSprite("Armor/vest1v2.png", 12);
                        armProp[0].armorPiece = "MiddleBody";
                        armProp[0].offset = offset;
                        armProp[0].armorTier = 2;
                        armProp[0].scaleOffset = scaleOffset;
                        armProp[0].armorPoints = 350;

                        armProp[1].sprite = ModAPI.LoadSprite("Armor/belt.png", 12);
                        armProp[1].armorPiece = "LowerBody";
                        armProp[1].offset = offset;
                        armProp[1].armorTier = 2;
                        armProp[1].scaleOffset = scaleOffset;
                        armProp[1].armorPoints = 250;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"), 
                    NameOverride = "[Manchester] Vest Variant 2", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "3b",
                    CategoryOverride = ModAPI.FindCategory(" SAS"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/vestv2icon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Armor/vest2v2.png", 12); 

                        int PartCount = 2;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f);                  
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Armor/vest2.png", 12);
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;
                        prop.armorPoints = 350;
                        armor.prop = prop;
                        armor.SetProperties();
                        
                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = ModAPI.LoadSprite("Armor/vest2v2.png", 12);
                        armProp[0].armorPiece = "MiddleBody";
                        armProp[0].offset = offset;
                        armProp[0].armorTier = 2;
                        armProp[0].scaleOffset = scaleOffset;
                        armProp[0].armorPoints = 350;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[Manchester] Helmet Variant 1", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "2a",
                    CategoryOverride = ModAPI.FindCategory(" SAS"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/helmetv1icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/helmetv2.png", 17f);
 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/helmetv1.png", 17f);
                        prop.armorPoints = 150;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[Manchester] Helmet Variant 2", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "2b",
                    CategoryOverride = ModAPI.FindCategory(" SAS"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/helmetv2icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/helmetv2.png", 17f); 

                        ModAPI.CreateLight(Instance.transform, Color.cyan, 0.3f, 0.5f);
                        var childObject = new GameObject("GPNVG18");
                        childObject.transform.SetParent(Instance.transform);
                        childObject.transform.localPosition = new Vector2(-0.031f, 0.003f);
                        childObject.transform.localScale = new Vector3(0.07f, 0.07f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("Helmet/nightvisionglow.png");
                        childSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                        childSprite.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";


                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/helmetv2.png", 17f);
                        prop.armorPoints = 150;
                        prop.offset = new Vector2(4.2f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[Manchester] Helmet Variant 3", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "2c",
                    CategoryOverride = ModAPI.FindCategory(" SAS"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/helmetv3icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/helmetv3.png", 17f);

                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/helmetv3.png", 17f);
                        prop.armorPoints = 150;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[Manchester] Helmet Variant 4", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "2d",
                    CategoryOverride = ModAPI.FindCategory(" SAS"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/helmetv4icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/helmetv4.png", 17f);

                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/helmetv4.png", 17f);
                        prop.armorPoints = 150;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }			
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[Manchester] Helmet Variant 5", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "2e",
                    CategoryOverride = ModAPI.FindCategory(" SAS"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/helmetv5icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/helmetv5.png", 17f);

                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/helmetv5.png", 17f);
                        prop.armorPoints = 150;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }			
                        Instance.FixColliders();
                    }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "[Manchester] Helmet Variant 6", 
                    DescriptionOverride = "", 
                    NameToOrderByOverride = "2e",
                    CategoryOverride = ModAPI.FindCategory(" SAS"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/helmetv6icon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Helmet/helmetv6.png", 17f);

                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("Helmet/helmetv6.png", 17f);
                        prop.armorPoints = 150;
                        prop.offset = new Vector2(0f, 2f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }			
                        Instance.FixColliders();
                    }
                }
            );

 ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), 
                    NameOverride = "[Manchester] Variant 1",
                    DescriptionOverride = " ", 
                    NameToOrderByOverride = "1a",
                    CategoryOverride = ModAPI.FindCategory(" SAS"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/v1icon.png"),
                    AfterSpawn = (Instance) => 
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();

                        var Head = Instance.transform.Find("Head").gameObject;

                        Head.GetOrAddComponent<MultipleSpriteHumanBehaviour>().person = person;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Scale = 12;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Textures = new Texture2D[]
                        {
                            ModAPI.LoadTexture("Outfit/Variant 1.png"),
                        };
                    }
                }
            );    

 ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), 
                    NameOverride = "[Manchester] Variant 2",
                    DescriptionOverride = " ", 
                    NameToOrderByOverride = "1b",
                    CategoryOverride = ModAPI.FindCategory(" SAS"), 
                    ThumbnailOverride = ModAPI.LoadSprite("icons/v2icon.png"),
                    AfterSpawn = (Instance) => 
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();

                        var Head = Instance.transform.Find("Head").gameObject;

                        Head.GetOrAddComponent<MultipleSpriteHumanBehaviour>().person = person;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Scale = 12;
                        Head.GetComponent<MultipleSpriteHumanBehaviour>().Textures = new Texture2D[]
                        {
                            ModAPI.LoadTexture("Outfit/Variant 2.png"),
                        };
                    }
                }
            );    







        }












public class MultipleSpriteHumanBehaviour : MonoBehaviour
    {
        public Texture2D[] Textures = new Texture2D[0];
        public PersonBehaviour person;
        public int CurrentTexture = -2;
        public int Scale = 3;

        void Start()
        {
            SetTexture();
        }

        public void SetTexture()
        {
            if (Textures.Length == 0)
                return;

            if(CurrentTexture == -2)
            {
                CurrentTexture = UnityEngine.Random.Range(0, Textures.Length);
            }
            person.SetBodyTextures(Textures[CurrentTexture], null, null, Scale);
            for (int i = 0; i < person.Limbs.Length; i++)
            {
                person.Limbs[i].gameObject.GetComponent<PhysicalBehaviour>().RefreshOutline();
            }
        }
}    }
}
